#include <iostream>
#define ll long long
#define endl "\n"
using namespace std;

const ll maxn = 1e4,inf=-1e8;
ll din[maxn][maxn],n,s,p[maxn];

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    cin >> n >> s;
    for(ll i=0;i<n;i++){
        cin >> p[i];
    }
    for(ll i=0;i<n;i++){
        for(ll k=0;k<n;k++){
            din[i][k]=inf;
        }
    }
    din[0][0]=0;
    din[0][1]=-p[0];
    for(ll i=1;i<n;i++){
        for(ll k=0;k<n;k++){
            if(k>i+1){
                break;
            }
            if(k==0){
                din[i][k]=max(din[i-1][k],din[i-1][k+1]+p[i]);
                continue;
            }
            if(k==n-1){
                din[i][k]=max(din[i-1][k],din[i-1][k-1]-p[i]);
                continue;
            }
            din[i][k]=max(max(din[i-1][k],din[i-1][k-1]-p[i]),din[i-1][k+1]+p[i]);
        }
    }
    cout << din[n-1][0]-s*n << endl;
return 0;
}

